<?php
class gpress_char_detail_queries extends gp_game_general_queries {

	function chars_template($page="", $limit=40){

		global $wpdb;
		$template = $this->get_temp();
		// Game info template
		$template_url = GPRESS_URL . 'includes/frontend/templates/'.$template.'/';
		$temp = $this->html_get_contents($template_url.'chars.html'); // fetch template

		$page = $page!="" ? absint(esc_sql($page)) : 1;
		$xx = $page==1 ? 0 : $limit*($page-1);
		$lim = $limit==0 ? "" : ' LIMIT '.$xx.','.$limit;

		$chars = "";
		if(!isset($_POST['char_search'])){
			$sql = 'SELECT * FROM '.$wpdb->prefix.'gpress_content_images WHERE content_type="char" AND is_main=1 ORDER by id DESC';
			$result = $wpdb->get_results($sql.$lim);
			if(count($result)>0){
				foreach ($result as $r){

					$char = $this->get_char($r->content_id);
					$img = $this->img_converter($r,'thumb','photo');
					$chars .= '<a href="'.home_url().'/characters/'.$char->id.'/'.sanitize_title_with_dashes($this->quote_esc($char->name)).'/"><img src="'.$img.'"/><span>'.htmlspecialchars_decode($this->quote_esc($char->name)).'</span><br/></a>';


				}


			}

		}else{
			$search = $this->search_quote($_POST['char_search']);
			$result = $wpdb->get_results('SELECT * FROM '.$wpdb->prefix.'gpress_chars WHERE name LIKE "%'.$search.'%" OR aka LIKE "%'.$search.'%"');
			if(count($result)>0){

				foreach ( $result as $r ) {

					$img = $this->get_game_image($r->id, 'char');
					$img = $this->img_converter($img->main,'thumb','char');
					$chars .= '<a href="'.home_url().'/characters/'.$r->id.'/'.sanitize_title_with_dashes($this->quote_esc($r->name)).'/"><img src="'.$img.'"/><span>'.htmlspecialchars_decode($this->quote_esc($r->name)).'</span><br/></a>';
				}

			}else{

				$chars = $this->translate("There is no any result.");
			}


		}

		if(isset($sql)){
			$count = $wpdb->get_results($sql);
			$pagination_link = home_url().'/characters/page-';

			$pagination = count($count)>1 ? $this->pagination($page,$limit,count($count),$pagination_link) : "";

		}

		$temp = str_replace('{chars}',$chars,$temp);
		$temp = str_replace('{pagination}',$pagination,$temp);
		$temp = str_replace('{search}',$this->translate('Search'),$temp);

		return $temp;

	}



	function char_template($id,$char,$cat=""){
		@$img = $this->get_game_image($id,'char');
		$photo = $this->img_converter($img->main,'','char');
		$aka = $char->aka != "" & $cat == "" ? "<div class='gp-info'><b>".$this->translate('Also known as').": </b>".$char->aka.'</div>' : "";
		$sum = $char->sum != "" & $cat == "" ? "<div class='gp-info'><b>".$this->translate('Summary').": </b>".$char->sum.'</div>' : "";
		$cover_big_tag = $this->get_img_tags($img->main->img_id);

		$gal_html = "";
		//		 GALLERY
		if($img->img !="" && ($cat =="" || $cat =="gallery")) {
			$gal_html .= '<br/><div class="gp-gallery">';
			$gal_html .= $cat=="gallery" ? '<div style="display:block !important;margin-bottom: 10px"><a href="'.home_url().'/characters/'.$id.'/'.sanitize_title_with_dashes($char->name).'/"><< '.$char->name.'</a></div>' : "";
			foreach ( $img->img as $k => $i ) {
				$count    = $k + 1;
				$img_tags = $this->get_img_tags( $i->img_id );
				$gal_html .= '<div class="gp-gallery-item">
								<a href="' . $this->img_converter( $i ) . '" class="flipLightBox2">
									<img src="' . $this->img_converter( $i, 'thumb' ) . '" alt="flipLightBox Image ' . $count . '"/>
									<span>' . $img_tags->titles . $img_tags->people . $img_tags->chars . '</span>
								  </a>
							</div>';
				if($k==4 && $cat==""){
					$gal_html .= '<div class="spacer" style="clear: both;"></div><div style="display:block !important;"><a href="'.home_url().'/characters/'.$id.'/'.sanitize_title_with_dashes($char->name).'/gallery">>> '.$this->translate('Gallery').'</a></div>';
					break;
				}

			}

			$gal_html .= '</div>';
			$gal_html .= '<div class="spacer" style="clear: both;"></div><hr/>';
		}
			// Gameography
			$gp = $this->gameography($id);
			$gp_html = "";
			if($gp!="" && $cat == ""){
				$gp_html .= '<div class="gp-gp"><div class="gp-gp-title">'.$this->translate('Gameography').'</div>';
				usort($gp, function($a, $b) {
					return $b->year - $a->year;
				});
				foreach ($gp as $k => $g) {
					$bg = $k%2==0 ? ' gp-color' : "";
					$gp_html .= '<div class="gp-gp-item'.$bg.'">';
					$gp_html .= '<div class="gp-gp-cover"><img src="' . $g->cover . '"/></div>';
					$gp_html .= '<div class="gp-gp-content">' . $g->game . '<br/>' . str_replace('{x}',$this->quote_esc($g->person),$this->translate('by {x}')) . '</div>';
					$gp_html .= '</div>';
				}
				$gp_html .= '</div>';
			}

			$template = $this->get_temp();
			$template_url = GPRESS_URL . 'includes/frontend/templates/'.$template.'/';
			$temp = $this->html_get_contents($template_url.'char_info.html'); // fetch template
			$char_blank = GPRESS_URL.'includes/images/person_blank.png';

			$temp = str_replace('{photo}', $photo,$temp);
			$temp = str_replace('{cover_big_tag}', $cover_big_tag->titles.$cover_big_tag->people.$cover_big_tag->chars,$temp);
			$temp = str_replace('{aka}', $this->quote_esc($aka),$temp);
			$temp = str_replace('{sum}', $this->quote_esc($sum),$temp);
			$temp = str_replace('{gallery}', $gal_html,$temp);
			$temp = str_replace('{gameography}', $gp_html,$temp);
			$temp = str_replace('{template_url}', $template_url,$temp);
			$temp = str_replace('{name}', $this->quote_esc($char->name),$temp);
			$temp = str_replace('{char_blank}', $char_blank,$temp);
			$temp = str_replace("{next}",$this->translate('Next'), $temp); // lang replaces
			$temp = str_replace("{back}",$this->translate('Back'), $temp); // lang replaces


			return $temp;



	}

	function gameography($id){
		global $wpdb;
		$id = absint($id);
		$result = $wpdb->get_results('SELECT * FROM '.$wpdb->prefix.'gpress_crew WHERE char_id='.$id);
		$gp = array();
		$gameography = "";
		if(count($result)>0){

			foreach ($result as $k => $r){

				$game = $this->get_game($r->game_id);
				$gamelink = '<a href="'.home_url().'/games/'.$r->game_id.'/'.sanitize_title_with_dashes($game->title).'">'.$game->title.($game->year>0 ? ' ('.$game->year.')' : '').'</a>';
				$gp[$r->game_id]['game'] = $gamelink;
				$img = $this->get_game_image($r->game_id);
				$gameimg = $this->img_converter($img->main,"med", "cover");
				$gp[$r->game_id]['cover'] = $gameimg;
				$gp[$r->game_id]['year'] = $game->year;
				$person = $this->get_person($r->person_id);
				$p = '<a href="'.home_url().'/people/'.$r->person_id.'/'.sanitize_title_with_dashes($this->quote_esc($person->name)).'">'.$this->quote_esc($person->name).'</a>';
				$gp[$r->game_id]['person'] .= $gp[$r->game_id]['person']=="" ? $p : ", ".$p;


			}
			$gp2 = array();
			$xx = 0;
			foreach ($gp as $g){
				$gp2[$xx] = $g;
				$xx++;
			}
			$gp_json = json_encode($gp2);
			$gameography = json_decode($gp_json);
		}

		return $gameography;

	}

	function add_char(){
		if(isset($_POST['p_name'])){
			$id = $this->insert_char();
			print('<script>window.location.href="admin.php?page=gp-chars&id='.$id.'&added=added"</script>');
		}
		$photo     = GPRESS_URL . 'includes/images/nophoto.png';
		$temp      = $this->html_get_contents( GPRESS_URL . 'includes/admin/pages/char.html' );
		$temp      = str_replace( '{name:lang}', $this->translate( 'Name' ), $temp );
		$temp      = str_replace( '{aka:lang}', $this->translate( 'AKA' ), $temp );
		$temp      = str_replace( '{sum:lang}', $this->translate( 'Summary' ), $temp );
		$temp      = str_replace( '{submit-button}', $this->translate( 'Save Changes' ), $temp );
		$temp      = str_replace( '{up-photo:lang}', $this->translate( 'Upload a photo' ), $temp );
		$temp      = str_replace( '{photo:lang}', $this->translate( 'Photograph' ), $temp );
		$temp      = str_replace( '{return:lang}', $this->translate( 'Return to characters' ), $temp );
		$temp      = str_replace( '{return-url}', admin_url( 'admin.php?page=gp-chars' ), $temp );

		// Edit values
		$temp = str_replace( '{name}', '', $temp );
		$temp = str_replace( '{aka}', '', $temp );
		$temp = str_replace( '{sum}', '', $temp );
		$temp = str_replace( '{links}', '', $temp );
		$temp = str_replace( '{photo}', $photo, $temp );
		$temp = str_replace( '{id}', '', $temp );
		echo $temp;

	}

	function insert_char(){
		global $wpdb;
		$id = "";
		if(isset($_POST['p_name'])){

			@$name = sanitize_text_field(trim($_POST['p_name']));
			@$sum = sanitize_textarea_field(trim($_POST['p_sum']));
			@$aka = sanitize_text_field(trim($_POST['p_aka']));

			$wpdb->insert(
				$wpdb->prefix.'gpress_chars',
				array(
					'name' => $name,
					'sum' => $sum,
					'aka' => $aka,

				)

			);
			$id = $wpdb->insert_id;

			@$p_source=$_FILES['person_file']['tmp_name'];
			@$filetype=$_FILES['person_file']['type'];
			@$pos = strpos($filetype,'image');
			if($pos !== false){
				$date = new DateTime();
				$uzanti = '.jpg';
				$img_name= sha1($date->format('Y-m-d-H-i-s')."-".microtime());

				$cr_folder = $this->create_img_file();
				$folder = $cr_folder['folder'];
				$image = $folder.$img_name.$uzanti;
				$big = $folder.$img_name.'_big'.$uzanti;
				$med = $folder.$img_name.'_med'.$uzanti;
				$thumb =  $folder.$img_name.'_thumb'.$uzanti;
				if(move_uploaded_file($p_source, $image)) {
					if($_FILES['person_file']['type']=="image/png"){
						$this->png2jpg($image,$image,100);
					};
					if($_FILES['person_file']['type']=="image/gif"){
						$this->gif2jpg($image,$image,100);
					}

					$this->image_size( $image, $big, 270);
					$this->image_size( $image, $med, 100);
					$this->image_crop( $image, $thumb, 180, 180);
				}

				$save_folder = $cr_folder['file'];
				$boyut= getimagesize($image);
				$byt=$boyut[0]."x".$boyut[1];
				$filesize=filesize($image);
				$wpdb->insert(
					$wpdb->prefix.'gpress_images',
					array(
						'name' => $img_name,
						'img_size' => $byt,
						'file_size' => $filesize,
						'file' => $save_folder,
						'file_type' => $uzanti,
						'type' => 'character'
					)
				);
				$last_id = $wpdb->insert_id;

				$wpdb->insert(
					$wpdb->prefix.'gpress_content_images',
					array(
						'img_id' => absint($last_id),
						'img_name' => $img_name,
						'img_size' => $byt,
						'file' => $save_folder,
						'file_type' => $uzanti,
						'type' => 'character',
						'content_id'=> absint($id),
						'content_type' => "char",
						'is_main' => absint(1)
					)
				);


			}


		}
		return $id;
	}

	function edit_char($id){
		if(@$_GET['c_gallery']!="edit") {
			if ( isset( $_POST['p_name'] ) ) {
				$this->update_char();
				?>
				<div class="updated notice">
					<p><?php echo $this->quote_esc($_POST['p_name']) ?> <?php echo $this->translate(  'has been updated.' ) ?></p>
				</div>
				<?php
			}
			$char      = $this->get_char( $id );
			$get_photo = $this->get_main_img( $id, 'char' );
			$photo     = $get_photo != "" ? $get_photo : GPRESS_URL . 'includes/images/nophoto.png';
			$temp      = $this->html_get_contents( GPRESS_URL . 'includes/admin/pages/char.html' );
			$fp = '<p>';
			$fp .= '<a href="'.home_url('characters/'.$id.'/'.sanitize_title_with_dashes($char->name)).'" target="_blank">'.$this->translate('View the content').'</a>';
			$fp .= '&nbsp;&nbsp;&nbsp;<a href="'.admin_url('admin.php?page=gp-chars&id='.$id.'&cat=gallery').'">'.$this->translate('Edit Gallery').'</a>';
			$fp .= '</p>';

			$temp      = str_replace('{links}',$fp,$temp);
			$temp      = str_replace( '{name:lang}', $this->translate( 'Name' ), $temp );
			$temp      = str_replace( '{aka:lang}', $this->translate( 'AKA' ), $temp );
			$temp      = str_replace( '{sum:lang}', $this->translate( 'Summary' ), $temp );
			$temp      = str_replace( '{submit-button}', $this->translate( 'Save Changes' ), $temp );
			$temp      = str_replace( '{up-photo:lang}', $this->translate( 'Upload a photo' ), $temp );
			$temp      = str_replace( '{photo:lang}', $this->translate( 'Photograph' ), $temp );
			$temp      = str_replace( '{return:lang}', $this->translate( 'Return to characters' ), $temp );
			$temp      = str_replace( '{return-url}', admin_url( 'admin.php?page=gp-chars' ), $temp );

			// Edit values
			$temp = str_replace( '{name}', $this->quote_esc($char->name), $temp );
			$temp = str_replace( '{aka}', $this->quote_esc($char->aka), $temp );
			$temp = str_replace( '{sum}', $this->quote_esc($char->sum), $temp );
			$temp = str_replace( '{photo}', $photo, $temp );
			$temp = str_replace( '{id}', $id, $temp );


			echo $temp;
			if(@$_GET['added']=="added"){
				?>
				<div class="updated notice">
					<p><?php echo $char->name.' '.$this->translate('has been added.')?></p>
				</div>
				<?php
			}
		}

	}

	function update_char(){
		global $wpdb;
		if(isset($_POST['p_name'])){

			@$name = $this->quote_slash(sanitize_text_field(trim(htmlspecialchars($_POST['p_name'], ENT_QUOTES))));
			@$sum = sanitize_textarea_field(trim($_POST['p_sum']));
			@$aka = sanitize_text_field(trim($_POST['p_aka']));
			@$id = sanitize_text_field(trim($_POST['p_id']));

			$wpdb->update(
				$wpdb->prefix.'gpress_chars',
				array(
					'name' => $name,
					'sum' => $sum,
					'aka' => $aka,

				),
				array(
					'id'=> absint($id)
				)
			);

			@$p_source=$_FILES['person_file']['tmp_name'];
			@$filetype=$_FILES['person_file']['type'];
			@$pos = strpos($filetype,'image');
			if($pos !== false){
				$date = new DateTime();
				$uzanti = '.jpg';
				$img_name= sha1($date->format('Y-m-d-H-i-s')."-".microtime());

				$cr_folder = $this->create_img_file();
				$folder = $cr_folder['folder'];
				$image = $folder.$img_name.$uzanti;
				$big = $folder.$img_name.'_big'.$uzanti;
				$med = $folder.$img_name.'_med'.$uzanti;
				$thumb =  $folder.$img_name.'_thumb'.$uzanti;
				if(move_uploaded_file($p_source, $image)) {
					if($_FILES['person_file']['type']=="image/png"){
						$this->png2jpg($image,$image,100);
					};
					if($_FILES['person_file']['type']=="image/gif"){
						$this->gif2jpg($image,$image,100);
					}

					$this->image_size( $image, $big, 270);
					$this->image_size( $image, $med, 100);
					$this->image_crop( $image, $thumb, 180, 180);
				}

				$save_folder = $cr_folder['file'];
				$boyut= getimagesize($image);
				$byt=$boyut[0]."x".$boyut[1];
				$filesize=filesize($image);
				$wpdb->insert(
					$wpdb->prefix.'gpress_images',
					array(
						'name' => $img_name,
						'img_size' => $byt,
						'file_size' => $filesize,
						'file' => $save_folder,
						'file_type' => $uzanti,
						'type' => 'character'
					)
				);
				$last_id = $wpdb->insert_id;

				$wpdb->update(
					$wpdb->prefix.'gpress_content_images',
					array(
						'is_main' => 0,

					),
					array(
						'content_id'=> absint($id),
						'content_type' => "char",
						'is_main' => 1
					)
				);

				$wpdb->insert(
					$wpdb->prefix.'gpress_content_images',
					array(
						'img_id' => absint($last_id),
						'img_name' => $img_name,
						'img_size' => $byt,
						'file' => $save_folder,
						'file_type' => $uzanti,
						'type' => 'character',
						'content_id'=> absint($id),
						'content_type' => "char",
						'is_main' => absint(1)
					)
				);


			}


		}
	}


	// Game gallery
	function gallery($id){
		if(isset($_POST['upload_pics'])){
			$this->upload_all_images($id,'char','gallery_files');
			?>
            <div class="updated notice">
                <p><?php echo $this->translate(  'Pictures has been uploaded.' ) ?></p>
            </div>
			<?php

		}
		$this->gallery_action($id);
		$img = $this->get_game_image($id,"char");

		?>
        <script type="text/javascript">
            jQuery(document).ready(function () {
                $("select#gp-game-gallery").imagepicker({
                    hide_select:  true,
                });

                var container = $("select.image-picker.masonry").next("ul.thumbnails");
                container.imagesLoaded(function(){
                    container.masonry({
                        itemSelector:   "li",
                    });
                });


                $("form").submit(function() {
                    if ($('input.action-gallery').val() == "<?php echo $this->translate("Apply")?>") {
                        if($('#action-time').val()=="delete") {
                            var c = confirm("<?php echo $this->translate('Are you sure?')?>");
                            return c;
                        }
                    }
                });



            });

        </script>

        <div class="game-op" style="top: 5px;position: relative;padding:30px">
            <form method="post" action="" enctype="multipart/form-data">
                <div style="display: block">
                    <div style="float: left;">
                        <select  name="action_sel" id="action-time">
                            <option value=""><?php echo $this->translate('Action')?></option>
                            <option value="cover"><?php echo $this->translate('Make Profile Picture')?></option>
                            <option value="go"><?php echo $this->translate('Edit Picture')?></option>
                            <option value="delete"><?php echo $this->translate('Delete')?></option>
                        </select>
                        <input type="submit" value="<?php echo $this->translate('Apply')?>" name="gallery_action" class="button button-primary action-gallery">

                    </div>
                    <div style="float: right;position: relative;margin-right: 150px">
                        <div class="upload-btn-wrapper">
                            <button class="btn"><?php echo "&#x2191; ".$this->translate('Upload Pictures')?></button>
                            <input type="file" name="gallery_files[]" multiple="multiple"/>

                        </div>
                        <input type="submit" value="<?php echo $this->translate('Save')?>" name="upload_pics" class="btn button button-primary" style="height: 35px">
                    </div>

                </div>
                <br/><br/><br/>
				<?php

				echo '<select class="image-picker masonry show-html" id="gp-game-gallery" name="gp_gallery">';
				echo '<option value=""></option>';
				if($img!="") {
					echo( isset( $img->main ) ? '<option data-img-src="' . $this->img_converter( $img->main, 'big' ) . '" value="' . $img->main->img_id . '" selected="selected">' . $img->main->img_id . '</option>' : '' );
					if(isset($img->img)){
						foreach ($img->img as $i){
							echo '<option data-img-src="' . $this->img_converter( $i, 'big' ) . '" value="' . $i->img_id . '">' . $i->img_id . '</option>';
						}
					}
				}
				echo '</select>';
				?>
            </form>
        </div>
		<?php

	}


	function gallery_action($id){
		global $wpdb;
		if(isset($_POST['gallery_action'])){

			// Cover
			if(@$_POST['action_sel'] == "cover"){
				if(@$_POST['gp_gallery'] != ""){

					@$img = absint($_POST['gp_gallery']);
					$wpdb->update(
						$wpdb->prefix.'gpress_content_images',
						array(
							'is_main' => 0,

						),
						array(
							'content_id'=> absint($id),
							'content_type' => "char",
							'is_main' => 1
						)
					);
					$wpdb->update(
						$wpdb->prefix.'gpress_content_images',
						array(
							'is_main' => 1,

						),
						array(
							'content_id'=> absint($id),
							'content_type' => "char",
							'img_id' => $img
						)
					);

					?>
                    <div class="updated notice">
                        <p><?php echo $this->translate(  'The profile picture has been changed.' ) ?></p>
                    </div>
					<?php
				}
			}else if(@$_POST['action_sel'] == "delete"){
				@$img = absint($_POST['gp_gallery']);
				$result = $wpdb->get_results('SELECT * FROM '.$wpdb->prefix.'gpress_images WHERE id='.$img);
				if(count($result)>0){
					foreach ($result as $r){
						$check = $wpdb->get_results('SELECT * FROM '.$wpdb->prefix.'gpress_content_images WHERE is_main=1 AND img_id='.$r->id);
						if(count($check) == 0) {
							$org   = GPRESS_FILE . DIRECTORY_SEPARATOR . 'includes' . DIRECTORY_SEPARATOR . str_replace( '/', DIRECTORY_SEPARATOR, $r->file ) . $r->name . $r->file_type;
							$big   = GPRESS_FILE . DIRECTORY_SEPARATOR . 'includes' . DIRECTORY_SEPARATOR . str_replace( '/', DIRECTORY_SEPARATOR, $r->file ) . $r->name . "_big" . $r->file_type;
							$med   = GPRESS_FILE . DIRECTORY_SEPARATOR . 'includes' . DIRECTORY_SEPARATOR . str_replace( '/', DIRECTORY_SEPARATOR, $r->file ) . $r->name . "_med" . $r->file_type;
							$thumb = GPRESS_FILE . DIRECTORY_SEPARATOR . 'includes' . DIRECTORY_SEPARATOR . str_replace( '/', DIRECTORY_SEPARATOR, $r->file ) . $r->name . "_thumb" . $r->file_type;
							if ( file_exists( $org ) ) {
								unlink( $org );
							}
							if ( file_exists( $big ) ) {
								unlink( $big );
							}
							if ( file_exists( $med ) ) {
								unlink( $med );
							}
							if ( file_exists( $thumb ) ) {
								unlink( $thumb );
							}
							$wpdb->delete(
								"{$wpdb->prefix}gpress_images",
								array( 'id' => $r->id ),
								array( '%d' )
							);
							$wpdb->delete(
								"{$wpdb->prefix}gpress_content_images",
								array( 'img_id' => $r->id ),
								array( '%d' )
							);
							?>
                            <div class="updated notice">
                                <p><?php echo $this->translate( 'The picture has been deleted.' ) ?></p>
                            </div>
							<?php
						}else{
							?>
                            <div class="error notice">
                                <p><?php echo $this->translate( 'The profile pictures cannot be deleted.' ) ?></p>
                            </div>
							<?php
						}

					}
				}
			}else if(@$_POST['action_sel']=="go"){
				@$img = absint($_POST['gp_gallery']);
				if(@$_POST['gp_gallery']!="") {
					print( '<script>window.location.href="admin.php?page=gp-gallery&id=' . $img . '"</script>' );

				}
			}

			//


		}

	}


}