<?php
class gp_game_langs_queries extends gp_game_general_queries {

	function lang_new(){
		?>
		<div class="game-op" style="top: 50px;position: relative">

		<form method="post" action="">
			<label><b><?php echo $this->translate('ISO Language Name')?>: </b></label><br/>
			<input type="text" name="iso" value="" style="width: 40%"/><br/>

			<label><b><?php echo $this->translate('Native Name')?>: </b></label><br/>
			<input type="text" name="org" value="" style="width: 40%"/><br/>
			<label><b><?php echo $this->translate('Language Code')?>: </b></label><br/>
			<input type="text" name="code" value="" style="width: 40%"/><br/>

			<?php submit_button($this->translate('Add'));?>
		</form>
		<a href="<?php echo admin_url('admin.php?page=gp-langs')?>"><?php echo $this->translate('Return Languages')?></a>
		</div>
		<?php
		if(isset($_POST['iso'])){
			$lastid= $this->insert_lang();
			print('<script>window.location.href="admin.php?page=gp-langs&id='.$lastid.'&added=added"</script>');
		}
	}
	// Insert game language
	function insert_lang(){
		global $wpdb;
		@$iso = sanitize_text_field(trim($_POST['iso']));
		@$code = sanitize_text_field(trim($_POST['code']));
		@$org = sanitize_text_field(trim($_POST['org']));
		$wpdb->insert(
			$wpdb->prefix.'gpress_langs',
			array(
				'iso_name' => $iso,
				'org_name' => $org,
				'code' => $code,
			)
		);
		return $wpdb->insert_id;
	}


	function lang_edit($id){
		if(isset($_POST['iso'])){
			$this->update_lang($id);
			?>
			<div class="updated notice">
				<p><?php echo $_POST['iso']?> <?php echo $this->translate('has been updated.')?></p>
			</div>
			<?php
		}


		$lang = $this->get_lang($id);
		?>
		<div class="game-op" style="top: 50px;position: relative">

			<form method="post" action="">
                <label><b><?php echo $this->translate('ISO Language Name')?>: </b></label><br/>
				<input type="text" name="iso" value="<?php echo $lang->iso_name?>" style="width: 40%"/><br/>

                <label><b><?php echo $this->translate('Native Name')?>: </b></label><br/>
				<input type="text" name="org" value="<?php echo $lang->org_name?>" style="width: 40%"/><br/>
                <label><b><?php echo $this->translate('Language Code')?>: </b></label><br/>
				<input type="text" name="code" value="<?php echo $lang->code?>" style="width: 40%"/><br/>

				<?php submit_button($this->translate('Save Changes'));?>
			</form>
			<a href="<?php echo admin_url('admin.php?page=gp-langs')?>"><?php echo $this->translate('Return Languages')?></a>
		</div>
		<?php
		if(@$_GET['added']=="added"){
			?>
			<div class="updated notice">
				<p><?php echo $lang->iso_name?> <?php echo $this->translate('has been added.')?></p>
			</div>
			<?php
		}
	}



	function update_lang($id){

		global $wpdb;
		@$iso = sanitize_text_field(trim($_POST['iso']));
		@$code = sanitize_text_field(trim($_POST['code']));
		@$org = sanitize_text_field(trim($_POST['org']));
		$wpdb->update(
			$wpdb->prefix.'gpress_langs',
			array(
				'iso_name' => $iso,
				'org_name' => $org,
				'code' => $code,
			),
			array(
				'id'=> esc_sql($id)
			)
		);
	}

	function load_lang($id){
	    global $wpdb;
	    $id = absint(esc_sql($id));
	    $lang = $wpdb->get_var('SELECT code FROM '.$wpdb->prefix.'gpress_langs WHERE id='.$id);
	    if(@$lang != ""){
             $json = $this->html_get_contents(GPRESS_URL.'includes/helpers/lang.json');
             $schema = json_decode($json);
             $x = 0;
             foreach ($schema as $s){
                 $check = $wpdb->get_results('SELECT * FROM '.$wpdb->prefix.'gpress_content_langs WHERE lang_code="'.$lang.'" AND hash="'.$s->hash.'"');
                 if(count($check)==0){
                     $x++;
                     $wpdb->insert($wpdb->prefix.'gpress_content_langs',
                         array(
                            'lang_id' => $id,
                             'lang_code' => $lang,
                             'english' => $s->english,
                             'hash' => $s->hash
                         )
                     );
                 }
             }
		    ?>
            <div class="updated notice">
                <p><?php echo str_replace("{x}",$x,$this->translate('{x} items have been added.'))?></p>
            </div>
		    <?php
        }

    }




}