<?php
class gp_game_translate_queries extends gp_game_general_queries{

	function tr_new($id){
		$lang = $this->get_lang($id);
		if(@$_GET['added']=="not"){
			?>
            <div class="error notice">
                <p><?php echo $this->translate('This translation has been already added.')?></p>
            </div>
			<?php
		}
		?>
		<div class="game-op" style="top: 50px;position: relative">

			<form method="post" action="">
				<label><b>English: </b></label><br/>
				<textarea name="english"  style="width: 40%"></textarea><br/>

				<label><b><?php echo $lang->org_name?> </b></label><br/>
				<textarea name="translate"  style="width: 40%"></textarea><br/>

				<?php submit_button($this->translate('Add'));?>
			</form>
			<a href="<?php echo admin_url('admin.php?page=gp-langs&translate='.$id)?>"><?php echo $this->translate('Return Translations')?></a>
		</div>
		<?php
		if(isset($_POST['english'])){
			$hash= $this->insert_tr($id,$lang->code);
			if($hash!="") {
				print( '<script>window.location.href="' . admin_url( "admin.php?page=gp-langs&translate=" . $id . "&hash=" . $hash . "&added=added" ) . '"</script>' );
			}else{
				print( '<script>window.location.href="' . admin_url( "admin.php?page=gp-langs&translate=" . $id . "&add=new&added=not" ) . '"</script>' );
            }
		}
	}

	function insert_tr($id,$code){
		global $wpdb;
		@$eng = sanitize_textarea_field(trim($_POST['english']));
		@$tr = sanitize_textarea_field(trim($_POST['translate']));
		$id = esc_sql($id);
		$hash = $this->hash($eng);
		$result = $wpdb->get_results('SELECT * FROM '.$wpdb->prefix.'gpress_content_langs WHERE hash="'.$hash.'" AND lang_id='.$id);
		if(count($result)==0) {
			$wpdb->insert(
				$wpdb->prefix . 'gpress_content_langs',
				array(
					'lang_id'     => $id,
					'lang_code'   => $code,
					'english'     => $eng,
					'translation' => $tr,
					'hash'        => $hash,
				)
			);
		}else{
		    $hash="";
        }
		return $hash;

    }



	function get_translate($id){
	    global $wpdb;
	    $id = esc_sql($id);
	    $hash = isset($_GET['hash']) ? esc_sql($_GET['hash']) : "";
	    $tr ="";
	    if($hash !=""){
	        $result = $wpdb->get_results('SELECT * FROM '.$wpdb->prefix.'gpress_content_langs WHERE lang_id='.$id.' AND hash="'.$hash.'"');
	        if(count($result)>0){
	            foreach ($result as $r){
	                $tr = $r;
                }
            }
        }
	    return $tr;

    }

    function update_tr($lang_id){
	    global $wpdb;
	    @$eng = sanitize_textarea_field(trim($_POST['english']));
	    @$tr = sanitize_textarea_field(trim($_POST['translate']));
	    @$id = esc_sql(sanitize_text_field($_POST['id']));
	    $hash = $this->hash($eng);
	    $result = $wpdb->get_results('SELECT * FROM '.$wpdb->prefix.'gpress_content_langs WHERE hash="'.$hash.'" AND lang_id='.$lang_id.' AND id!='.$id);
	    if(count($result)==0) {
		    $wpdb->update(
			    $wpdb->prefix . 'gpress_content_langs',
			    array(
				    'lang_id'     => $lang_id,
				    'english'     => $eng,
				    'translation' => $tr,
				    'hash'        => $hash,
			    ),
			    array(
				    'id' => $id,
			    )

		    );
	    }else{
	        $hash="";
        }
	    return $hash;

    }


	function tr_edit($id){
	    $tr = $this->get_translate($id);
		$lang = $this->get_lang($id);
		$next_url = $this->next_tr($id,$_GET['hash']);
		if(isset($_POST['save_changes'])){
			$hash = $this->update_tr($id);
			if($hash!="") {
				print( '<script>window.location.href="' . admin_url( "admin.php?page=gp-langs&translate=" . $id . "&hash=" . $hash . "&added=updated" ) . '"</script>' );
			}else{
			    $hash = esc_sql($_GET['hash']);
				print( '<script>window.location.href="' . admin_url( "admin.php?page=gp-langs&translate=" . $id . "&hash=" . $hash . "&added=not" ) . '"</script>' );
            }
		}
		else if(isset($_POST['next_sub'])){
			$hash = $this->update_tr($id);
			print( '<script>window.location.href="' . admin_url( "admin.php?page=gp-langs&translate=" . $id . "&hash=" . $next_url ) . '"</script>' );
        }
		if(@$_GET['added']=="not"){
			?>
            <div class="error notice">
                <p><?php echo $this->translate('This translation has been already added.')?></p>
            </div>
			<?php
		}

		if(@$_GET['added'] == "updated") {
			?>
            <div class="updated notice">
                <p><?php echo $this->translate('Translation has been updated.')?></p>
            </div>
			<?php
		}
		?>
        <div class="game-op" style="top: 50px;position: relative">

            <form method="post" action="">
                <label><b>English: </b></label><br/>
                <textarea name="english"  style="width: 40%"><?php echo $tr->english?></textarea><br/>

                <label><b><?php echo $lang->org_name?> </b></label><br/>
                <textarea name="translate"  style="width: 40%"><?php echo $tr->translation?></textarea><br/><br/><br/>
                <input type="hidden" name="id" value="<?php echo $tr->id;?>"/>

				<?php echo '<div style="float:left;"><input type="submit" name="save_changes" class="button" value="'.$this->translate('Save Changes').'" style="background-color: #1da4dd; color: #fff;border-color: #1da1f2;float: left"/>&nbsp;&nbsp;</div>'?>
	            <?php
	            if($next_url!=""){
		            echo '<div><input type="submit" name="next_sub" class="button" value="'.$this->translate('Save & Next').'" style="background-color: #1ec846; color: #fff;border-color: #1ec846;float: left"/></div>';
	            }
	            ?>
                <br/><br/>
            </form>
            <a href="<?php echo admin_url('admin.php?page=gp-langs&translate='.$id)?>"><?php echo $this->translate('Return Translations')?></a>
        </div>
		<?php
		if(@$_GET['added']=="added"){
			?>
            <div class="updated notice">
                <p><?php echo $this->translate('Translation has been added.')?></p>
            </div>
			<?php
		}
    }

    function next_tr($id,$hash){
	    global $wpdb;
	    $hash = esc_sql($hash);
	    $id = absint(esc_sql($id));
	    $get_id = $wpdb->get_var('SELECT id FROM '.$wpdb->prefix.'gpress_content_langs WHERE hash="'.$hash.'" AND lang_id='.$id);
	    $results = $wpdb->get_results('SELECT * FROM '.$wpdb->prefix.'gpress_content_langs WHERE lang_id='.$id.' AND id<'.$get_id.' ORDER by id DESC LIMIT 1');
	    $url = "";
	    if(count($results)>0){
	        foreach ($results as $r){

	            $url = 'admin.php?page=gp-langs&translate='.$id.'&hash='.$r->hash;
            }
        }
        return $url;

    }


}