<?php
// Add action title
add_filter('pre_get_document_title','plugin_gpress_title_tag');

add_filter('the_title','plugin_gpress_title');
add_filter('the_title','plugin_gpress_people_title');
add_filter('the_title','plugin_gpress_chars_title');
add_filter('the_title','plugin_gpress_ops_title');
add_filter('the_title','plugin_gpress_comps_title');

// Query filter
add_filter( 'gp_gpress_game_query', 'gp_gpress_get_game_query' );
add_filter( 'gp_gpress_person_query', 'gp_gpress_get_person_query' );
add_filter( 'gp_gpress_char_query', 'gp_gpress_get_char_query' );

// Add query variables
add_filter('query_vars', 'gpress_game_parameter');

// Edit filter
add_filter( 'edit_post_link', 'gpress_edit_remove' );



// Variables function

function gpress_game_parameter($vars){
	//games vars
	$vars[] = "game_id";
	$vars[] = "game_title";
	$vars[] = "game_cat";
	$vars[] = "game_p";
	//people vars
	$vars[] = "person_id";
	$vars[] = "person_name";
	$vars[] = "person_cat";
	$vars[] = "person_p";
	//chars vars
	$vars[] = "char_id";
	$vars[] = "char_name";
	$vars[] = "char_cat";
	$vars[] = "char_p";
	//themes vars
	$vars[] = "theme_id";
	$vars[] = "theme_name";
	$vars[] = "theme_p";
	//platforms vars
	$vars[] = "platform_id";
	$vars[] = "platform_name";
	$vars[] = "platform_p";
	//genres vars
	$vars[] = "genre_id";
	$vars[] = "genre_name";
	$vars[] = "genre_p";
	//modes vars
	$vars[] = "mode_id";
	$vars[] = "mode_name";
	$vars[] = "mode_p";
	//engines vars
	$vars[] = "engine_id";
	$vars[] = "engine_name";
	$vars[] = "engine_p";
	//perspectives vars
	$vars[] = "perspective_id";
	$vars[] = "perspective_name";
	$vars[] = "perspective_p";
	//companies vars
	$vars[] = "comp_id";
	$vars[] = "comp_name";
	$vars[] = "comp_p";
	return $vars;
}




// Game query function

function gp_gpress_get_game_query() {
	$id = get_query_var('game_id');
	$g = new gpress_game_detail_queries();
	$game = $g->get_game($id);
	return $game;
}

// Person query function

function gp_gpress_get_person_query(){
	@$id = get_query_var('person_id');
	$p = new gpress_person_detail_queries();
	$person = $p->get_person($id);
	return $person;
}

// Char query function


function gp_gpress_get_char_query(){
	@$id = get_query_var('char_id');
	$c = new gpress_char_detail_queries();
	$char = $c->get_char($id);
	return $char;
}


// Change title tag

function plugin_gpress_title_tag($title) {
	$gen = new gp_game_general_queries();
	if(get_query_var('game_id') !="") {
		$g     = apply_filters( 'gp_gpress_game_query', '' );
		$title = $gen->quote_esc($g->title) . ( $g->year > 0 ? " (" . $g->year . ")" : "" );
	}else if(get_query_var('person_id') !=""){
		$p = apply_filters( 'gp_gpress_person_query', '' );
		$title = $gen->quote_esc($p->name);
	}else if(get_query_var('char_id') !="") {
		$c     = apply_filters( 'gp_gpress_char_query', '' );
		$title = $gen->quote_esc($c->name);
	}else if(get_query_var('comp_id')!=""){
		$id = get_query_var('comp_id');
		$comp = new gpress_game_comps_queries();
		$c = $comp->get_comp($id);
		$title = $gen->quote_esc($c->name);
	}else{
		@$page = get_query_var('pagename');
		$bop = ucfirst(rtrim($page,'s'));
		$op = rtrim($page,'s');
		$opc = new gpress_game_op_queries();
		@$id = get_query_var($op.'_id');
		$title = $id!="" ? $opc->translate($bop).': '. str_replace('{x}',$opc->translate($gen->quote_esc($opc->get_op_name($page,$id)->name)),$opc->translate('{x} Games')) : $opc->translate(ucwords($page));


	}
	return $title;
}



// change title
function plugin_gpress_title($title) {
	$page = get_page_by_path('games');
	if( (in_the_loop() &&  is_page($page->ID)) && (!is_nav_menu_item())):
		return '';
	else:
		return $title;
	endif;
}

// change title person
function plugin_gpress_people_title($title) {
	$page = get_page_by_path('people');
	if( (in_the_loop() &&  is_page($page->ID)) && (!is_nav_menu_item())):
		return '';
	else:
		return $title;
	endif;
}

// change title char
function plugin_gpress_chars_title($title) {
	$page = get_page_by_path('characters');
	if( (in_the_loop() &&  is_page($page->ID)) && (!is_nav_menu_item())):
		return '';
	else:
		return $title;
	endif;
}

// change op titles
function plugin_gpress_ops_title($title){
	$op = new gpress_game_op_queries();
	$pages = array('platforms', 'modes','genres','themes','perspectives','engines');
	foreach ($pages as $p){
		$page = get_page_by_path($p);
		$page_name = get_query_var('pagename');
		$p_key = rtrim($page_name,'s');
		@$id = get_query_var($p_key.'_id');
		if((in_the_loop() &&  is_page($page->ID)) && (!is_nav_menu_item()) && ($id !="") ){

			$op_title = $op->get_op_name($page_name,$id);
			$new_title = $op->translate(ucfirst($p_key)).': '.str_replace('{x}',$op->translate($op->quote_esc($op_title->name)),$op->translate('{x} Games'));
			$title = $new_title;
		}
	}

	return $op->translate($title);

}

// change comps titles
function plugin_gpress_comps_title($title){
	$page = get_page_by_path('companies');
	@$id = get_query_var('comp_id');
	if((in_the_loop() &&  is_page($page->ID)) && (!is_nav_menu_item()) && ($id !="") ){
		$comp = new gpress_game_comps_queries();
		$c = $comp->get_comp($id);
		$title = $comp->quote_esc($c->name);
	}
	return $title;
}


// Edit function
function gpress_edit_remove(){
	return "";
}


// Menu langs

add_filter( 'wp_nav_menu_items', 'dynamic_label_change', 10, 2 );
function dynamic_label_change( $items, $args ) {
	$lang = new gp_game_translate_queries();
	if ($args->theme_location == 'topbar_navigation' || $args->theme_location == 'primary') {
		$items = str_replace("Characters", $lang->translate("Characters"), $items);
		$items = str_replace("People", $lang->translate("People"), $items);
		$items = str_replace("Games", $lang->translate("Games"), $items);
		$items = str_replace("Companies", $lang->translate("Companies"), $items);
		$items = str_replace("Platforms", $lang->translate("Platforms"), $items);
		$items = str_replace("Game Options", $lang->translate("Game Options"), $items);
		$items = str_replace("Genres", $lang->translate("Genres"), $items);
		$items = str_replace("Themes", $lang->translate("Themes"), $items);
		$items = str_replace("Perspectives", $lang->translate("Perspectives"), $items);
		$items = str_replace("Modes", $lang->translate("Modes"), $items);
		$items = str_replace("Engines", $lang->translate("Engines"), $items);
	}

	return $items;
}