<?php
//CREATING TABLE
function gpress_install_create_tables() {
	global $wpdb;


	$charset_collate = $wpdb->get_charset_collate();

	// 1.gpress_chars
	$sql = 'CREATE TABLE '.$wpdb->prefix.'gpress_chars (
  			    `id` bigint(21) NOT NULL AUTO_INCREMENT,
  			    `name` varchar(255) NOT NULL,  			    
  			    `sum` text NOT NULL,
  			    `aka` varchar(255) NOT NULL,
  			    `published` int(1) NOT NULL DEFAULT \'1\',
  			    PRIMARY KEY (`id`),
  				KEY `id` (`id`),
  				KEY `name` (`name`)  				
			) '.$charset_collate.';  ';

	//2.gpress_companies

	$sql .= 'CREATE TABLE '.$wpdb->prefix.'gpress_companies (
  				`id` int(11) NOT NULL AUTO_INCREMENT,
  				`name` varchar(255) NOT NULL,
  				`history` text NOT NULL,
  				`country` varchar(255) NOT NULL,
  				`comp_parent` varchar(255) NOT NULL,
  				`established` date NOT NULL,
  				`website` varchar(255) NOT NULL,
  				`logo` varchar(255) NOT NULL,
  				PRIMARY KEY (`id`),
                KEY `name` (`name`)
			) '.$charset_collate.';  ';

	//3.gpress_content_comps

	$sql .= 'CREATE TABLE '.$wpdb->prefix.'gpress_content_comps (
  				`id` bigint(21) NOT NULL AUTO_INCREMENT,
  				`com_id` int(11) NOT NULL,
  				`content_id` bigint(21) NOT NULL,
  				`content_type` varchar(30) NOT NULL,
  				PRIMARY KEY (`id`),
  				KEY `com_id` (`com_id`),
  				KEY `content_id` (`content_id`),
  				KEY `content_type` (`content_type`)
			) '.$charset_collate.'; ';

	//4.gpress_content_images

	$sql .= 'CREATE TABLE '.$wpdb->prefix.'gpress_content_images (
                `id` bigint(21) NOT NULL AUTO_INCREMENT,
                `img_id` bigint(21) NOT NULL,
                `content_id` bigint(21) NOT NULL,
                `img_name` varchar(255) NOT NULL,
                `content_type` varchar(32) NOT NULL,
                `file_type` varchar(32) NOT NULL,
                `file` varchar(32) NOT NULL,
                `type` varchar(32) NOT NULL,
                `img_size` varchar(32) NOT NULL,
                `is_main` int(1) NOT NULL,
                PRIMARY KEY (`id`),
                KEY `content_id` (`content_id`),
                KEY `content_type` (`content_type`),
                KEY `img_id` (`img_id`),
                KEY `is_main` (`is_main`)
			) '.$charset_collate.'; ';

	//5.gpress_content_langs

	$sql .= 'CREATE TABLE '.$wpdb->prefix.'gpress_content_langs (
  				`id` bigint(21) NOT NULL AUTO_INCREMENT,
  				`lang_id` int(5) NOT NULL,
  				`lang_code` varchar(15) NOT NULL,
  				`english` text NOT NULL,
  				`translation` text NOT NULL,
  				`hash` varchar(255) NOT NULL,
  				PRIMARY KEY (`id`),
                KEY `lang_id` (`lang_id`),
                KEY `hash` (`hash`),
                KEY `lang_code` (`lang_code`)
			) '.$charset_collate.'; ';

	//6.gpress_content_videos.sql

	$sql .= 'CREATE TABLE '.$wpdb->prefix.'gpress_content_videos (
  				`id` bigint(21) NOT NULL AUTO_INCREMENT,
  				`video_id` bigint(21) NOT NULL,
  				`content_id` bigint(21) NOT NULL,
  				`content_type` varchar(31) NOT NULL,
  				`source_id` varchar(255) NOT NULL,
  				`source` varchar(21) NOT NULL,
  				`thumb` varchar(255) NOT NULL,
  				`title` varchar(255) NOT NULL,
  				PRIMARY KEY (`id`),
  				KEY `video_id` (`video_id`),
  				KEY `content_id` (`content_id`),
  				KEY `content_type` (`content_type`),
  				KEY `source_id` (`source_id`)
			) '.$charset_collate.'; ';

	//7.gpress_crew

	$sql .= 'CREATE TABLE '.$wpdb->prefix.'gpress_crew (
  				`id` bigint(21) NOT NULL AUTO_INCREMENT,
  				`game_id` bigint(21) NOT NULL,
  				`person_id` bigint(21) NOT NULL,
  				`job_id` int(5) NOT NULL,
  				`char_id` bigint(21) NOT NULL,
  				`char_name` varchar(255) NOT NULL,
  				PRIMARY KEY (`id`),
                KEY `person_id` (`person_id`),
                KEY `char_id` (`char_id`),
                KEY `game_id` (`game_id`)
			) '.$charset_collate.'; ';

	//8.gpress_engines

	$sql .= 'CREATE TABLE '.$wpdb->prefix.'gpress_engines (
  				`id` int(11) NOT NULL AUTO_INCREMENT,
  				`name` varchar(255) NOT NULL,
  				`logo` varchar(255) NOT NULL,
  				PRIMARY KEY (`id`)
			) '.$charset_collate.'; ';

	//9.gpress_games

	$sql .= 'CREATE TABLE '.$wpdb->prefix.'gpress_games (
  				`id` bigint(20) NOT NULL AUTO_INCREMENT,
  				`title` varchar(255) NOT NULL,
  				`aka` varchar(255) NOT NULL,
  				`sum` text NOT NULL,
  				`year` int(11) NOT NULL,
  				`released` date NOT NULL,
  				`imdb_id` varchar(255) NOT NULL,  				
  				`news` text NOT NULL,
  				`reviews` text NOT NULL,
  				`published` enum(\'0\',\'1\') NOT NULL DEFAULT \'1\',
  				PRIMARY KEY (`id`),
                KEY `title` (`title`),
                KEY `aka` (`aka`),                 				
                KEY `year` (`year`),
                KEY `released` (`released`)
			) '.$charset_collate.'; ';

	//10.gpress_genres

	$sql .= 'CREATE TABLE '.$wpdb->prefix.'gpress_genres (
  				`id` int(11) NOT NULL AUTO_INCREMENT,
  				`name` varchar(255) NOT NULL,
  				PRIMARY KEY (`id`)  			
			) '.$charset_collate.'; ';

	//11.gpress_images.sql

	$sql .= 'CREATE TABLE '.$wpdb->prefix.'gpress_images (
  				`id` bigint(21) NOT NULL AUTO_INCREMENT,
  				`name` varchar(255) NOT NULL,
  				`img_size` varchar(32) NOT NULL,
  				`file_size` varchar(32) NOT NULL,
  				`file` varchar(32) NOT NULL,
  				`file_type` varchar(32) NOT NULL,
  				`type` varchar(32) NOT NULL,
  				`published` enum(\'0\',\'1\') NOT NULL DEFAULT \'1\',
  				PRIMARY KEY (`id`)                
			) '.$charset_collate.'; ';

	//12.gpress_jobs

	$sql .= 'CREATE TABLE '.$wpdb->prefix.'gpress_jobs (
  				`id` int(5) NOT NULL AUTO_INCREMENT,
  				`name` varchar(255) NOT NULL,
  				PRIMARY KEY (`id`)
			) '.$charset_collate.'; ';

	//13.gpress_langs

	$sql .= 'CREATE TABLE '.$wpdb->prefix.'gpress_langs (
  				`id` int(5) NOT NULL AUTO_INCREMENT,
  				`iso_name` varchar(255) NOT NULL,
  				`org_name` varchar(255) NOT NULL,
  				`code` varchar(10) NOT NULL,
  				PRIMARY KEY (`id`),
  				KEY `code` (`code`)
			) '.$charset_collate.'; ';

	//14.gpress_modes

	$sql .= 'CREATE TABLE '.$wpdb->prefix.'gpress_modes (
  				`id` int(5) NOT NULL AUTO_INCREMENT,
  				`name` varchar(255) NOT NULL,
  				PRIMARY KEY (`id`)  				
			) '.$charset_collate.'; ';

	//15.gpress_op

	$sql .= 'CREATE TABLE '.$wpdb->prefix.'gpress_op (
  				`game_id` bigint(21) NOT NULL,
  				`op_id` int(6) NOT NULL,
  				`type` varchar(30) NOT NULL,  				
                KEY `game_id` (`game_id`),
                KEY `op_id` (`op_id`),
                KEY `type` (`type`)
			) '.$charset_collate.'; ';

	//16.gpress_people

	$sql .= 'CREATE TABLE '.$wpdb->prefix.'gpress_people (
                `id` bigint(21) NOT NULL AUTO_INCREMENT,
                `name` varchar(255) NOT NULL,
                `imdb_id` varchar(255) NOT NULL,
                `real_name` varchar(255) NOT NULL,
                `aka` varchar(255) NOT NULL,
                `birthday` date NOT NULL,
                `deathday` date NOT NULL,
                `birthplace` varchar(255) NOT NULL,
                `bio` text NOT NULL,
                `zodiac` enum(\'Aries\',\'Taurus\',\'Gemini\',\'Cancer\',\'Leo\',\'Virgo\',\'Libra\',\'Scorpio\',\'Sagittarius\',\'Capricorn\',\'Aquarius\',\'Pisces\') NOT NULL,
                `published` int(1) NOT NULL DEFAULT \'1\',
                PRIMARY KEY (`id`),  
                KEY `name` (`name`),
                KEY `aka` (`aka`),
                KEY `birthday` (`birthday`),
                KEY `deathday` (`deathday`),
                KEY `zodiac` (`zodiac`)                 
			) '.$charset_collate.'; ';

	//17.gpress_perspectives

	$sql .= 'CREATE TABLE '.$wpdb->prefix.'gpress_perspectives (
  				`id` int(5) NOT NULL AUTO_INCREMENT,
  				`name` varchar(255) NOT NULL,
  				PRIMARY KEY (`id`)
			) '.$charset_collate.'; ';

	//18.gpress_platforms

	$sql .= 'CREATE TABLE '.$wpdb->prefix.'gpress_platforms (
  				`id` int(11) NOT NULL AUTO_INCREMENT,
  				`name` varchar(255) NOT NULL,
  				`logo` varchar(255) NOT NULL,
  				PRIMARY KEY (`id`)
			) '.$charset_collate.'; ';

	//19.gpress_rating

	$sql .= 'CREATE TABLE '.$wpdb->prefix.'gpress_rating (
  				`user` int(11) NOT NULL,
  				`content_id` bigint(21) NOT NULL,
  				`rating` decimal(3,1) NOT NULL,
  				`content` varchar(30) NOT NULL,
  				KEY `user` (`user`),
  				KEY `content_id` (`content_id`),  
  				KEY `content` (`content`)				
			) '.$charset_collate.'; ';

	//20.gpress_settings

	$sql .= 'CREATE TABLE '.$wpdb->prefix.'gpress_settings (
  				`type` varchar(30) NOT NULL,
  				`settings` text NOT NULL
			) '.$charset_collate.'; ';

	//21.gpress_templates

	$sql .= 'CREATE TABLE '.$wpdb->prefix.'gpress_templates (
  				`id` int(5) NOT NULL AUTO_INCREMENT,
  				`name` varchar(255) NOT NULL,
  				`description` text NOT NULL,
  				`code` varchar(255) NOT NULL,
  				`para` int(1) NOT NULL,
                `header` int(1) NOT NULL,
                `zindex` int(5) NOT NULL,
  				PRIMARY KEY (`id`)
			) '.$charset_collate.'; ';

	//22.gpress_themes

	$sql .= 'CREATE TABLE '.$wpdb->prefix.'gpress_themes (
  				`id` int(5) NOT NULL AUTO_INCREMENT,
  				`name` varchar(255) NOT NULL,
  				PRIMARY KEY (`id`)  				
			) '.$charset_collate.'; ';

	//23.gpress_videos

	$sql .= 'CREATE TABLE '.$wpdb->prefix.'gpress_videos (
  				`id` bigint(21) NOT NULL AUTO_INCREMENT,
  				`source_id` varchar(255) NOT NULL,
  				`source` varchar(35) NOT NULL,
  				`thumb` varchar(255) NOT NULL,
  				`title` varchar(255) NOT NULL,
  				PRIMARY KEY (`id`)
			) '.$charset_collate.'; ';
	



	if ( ! function_exists('dbDelta') ) {
		require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
	}

	dbDelta( $sql );

	add_option('gpress_db_version',GPRESS_DB_VERSION);
}




function gpress_install_insert_gpress_langs(){
	global $wpdb;
	$sqlfile = GPRESS_FILE.DIRECTORY_SEPARATOR.'includes'.DIRECTORY_SEPARATOR.'helpers'.DIRECTORY_SEPARATOR.'sql'.DIRECTORY_SEPARATOR.'gpress_langs.sql';
	if(file_exists($sqlfile)){
		$sql = file_get_contents($sqlfile);
		$sql = str_replace('prefix_',$wpdb->prefix,$sql);

		if ( ! function_exists('dbDelta') ) {
			require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
		}
		dbDelta( $sql );
		unlink($sqlfile);
	}

}


function gpress_install_insert_gpress_content_langs(){
	global $wpdb;
	$sqlfile = GPRESS_FILE.DIRECTORY_SEPARATOR.'includes'.DIRECTORY_SEPARATOR.'helpers'.DIRECTORY_SEPARATOR.'sql'.DIRECTORY_SEPARATOR.'gpress_content_langs.sql';
	if(file_exists($sqlfile)){
		$sql = file_get_contents($sqlfile);
		$sql = str_replace('prefix_',$wpdb->prefix,$sql);
		$wpdb->query( $sql );
		unlink($sqlfile);
	}

}

function gpress_install_insert_gpress_jobs(){
	global $wpdb;
	$sqljobs = GPRESS_FILE.DIRECTORY_SEPARATOR.'includes'.DIRECTORY_SEPARATOR.'helpers'.DIRECTORY_SEPARATOR.'sql'.DIRECTORY_SEPARATOR.'gpress_jobs.sql';
	if(file_exists($sqljobs)){
		$sqlj = file_get_contents($sqljobs);
		$sqlj = str_replace('prefix_',$wpdb->prefix,$sqlj);

		if ( ! function_exists('dbDelta') ) {
			require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
		}
		$wpdb->query( $sqlj );
		if(file_exists($sqljobs)) {
			unlink($sqljobs);
		}
	}
}



function gpress_install_insert_gpress_settings(){
	global $wpdb;
	$sqlfile = GPRESS_FILE.DIRECTORY_SEPARATOR.'includes'.DIRECTORY_SEPARATOR.'helpers'.DIRECTORY_SEPARATOR.'sql'.DIRECTORY_SEPARATOR.'gpress_settings.sql';
	if(file_exists($sqlfile)){
		$sql = file_get_contents($sqlfile);
		$sql = str_replace('prefix_',$wpdb->prefix,$sql);

		if ( ! function_exists('dbDelta') ) {
			require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
		}
		dbDelta( $sql );
		unlink($sqlfile);
	}

}

function gpress_install_insert_gpress_templates(){
	global $wpdb;
	$sqlfile = GPRESS_FILE.DIRECTORY_SEPARATOR.'includes'.DIRECTORY_SEPARATOR.'helpers'.DIRECTORY_SEPARATOR.'sql'.DIRECTORY_SEPARATOR.'gpress_templates.sql';
	if(file_exists($sqlfile)){
		$sql = file_get_contents($sqlfile);
		$sql = str_replace('prefix_',$wpdb->prefix,$sql);

		if ( ! function_exists('dbDelta') ) {
			require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
		}
		dbDelta( $sql );
		unlink($sqlfile);
	}

}

function gpress_install_activation($plugin)
{
	if( $plugin == plugin_basename( GPRESS_DIRECT_FILE ) ) {
		exit( wp_redirect( admin_url( 'admin.php?page=gamepress&activated=true' ) ) );
	}

}






